{ ------- Axes.pas ------- }
{ fichier inclus de graphker.pas pour trac des axes }

procedure TgrapheOsc.TraceTitreAxe(m : indiceVoieOsc;avecPoint : boolean);
var signeX,oldxtitre : integer;
    couleurLoc : TcolorRef;
    N : shortString;

Procedure myTextOut(S : shortString);
var  Largeur : LongInt;
begin
   if S='' then exit;
   with voie[m] do begin
       Largeur := canvas.TextWidth(S);
       canvas.TextOut(xTitre,yTitre,S);
       xTitre := xTitre+signeX*Largeur;
end end;

begin {traceTitreAxe}
    couleurLoc := MyColorToRGB(voie[m].couleur)   ;
    oldXtitre := voie[m].xTitre;
    signeX := +1;
    canvas.font.color := couleurLoc;
    if m=voieT
       then begin
//            setTextAlign(TA_right+TA_bottom);
            signeX := -1;
       end
       else  begin
                 case m of
                    voieB : begin
//                       setTextAlign(TA_right+TA_top);
                       signeX := -1;
                    end;
                    voieA : ;//setTextAlign(TA_left+TA_top);
                end;
           end;
        with voie[m] do begin
        N := nom[0]+' ('+UniteAff(exposant)+')';
        MyTextOut(N);
        xTitre := xTitre+signeX*LargCarac;
        rectangleTitre := rect(oldxtitre,ytitre,xtitre,ytitre+hautCarac);
        if monochrome and (m<>voieT) then begin
            inc(ytitre,hautCarac);
            if avecPoint then begin
               TraceMotif(xTitre+signeX*dimPoint,yTitre-hautCarac div 2,
                   voie[m].motif);
               xTitre := xTitre+signeX*LargCarac;
            end;
            canvas.pen.style := psSolid;
            canvas.pen.width := 1;
            canvas.pen.color := couleurLoc;
            dec(yTitre,hautCarac);
        end;
    end { monde[m] }
end; {traceTitreAxe}

procedure TgrapheOsc.DrawAxis;
var xAxeY,yAxeX : Integer;
    xNombreMax,xNombreMin,signeMargeX : integer;
    PointCourant : single;
    couleurAxe : TcolorRef;
    Xcentre : boolean;
    SigneAligneY : integer;

  procedure OutText(x,y : integer;S : string);
  begin
     canvas.TextOut(x,y,S);
  end;

Function YcorrectNombre(y : integer;m : indiceVoieOsc) : boolean;
begin with voie[m] do
     YcorrectNombre := (y>(CourbeTop+marge*3)) and (y<=CourbeBottom)
end;

Function YcorrectGrad(y : integer;m : indiceVoieOsc) : boolean;
begin with voie[m] do
     YcorrectGrad := (y>CourbeTop) and (y<=CourbeBottom)
end;

Function XcorrectNombre(x : integer) : boolean;
begin
     XcorrectNombre := (x>xNombreMin) and (x<xNombreMax)
end;

Function XcorrectGrad(x : integer) : boolean;
begin
     XcorrectGrad := (x>=limiteCourbe.left) and (x<limiteCourbe.right)
end;

Procedure WindowAxe(xr,yr : extended;m : indiceVoieOsc;var xi,yi : Integer);
begin
        WindowXY(xr,yr,m,xi,yi)
end;

Procedure graduationX(x,y : integer;quadrillage : boolean);
begin
  if quadrillage
       then segment(x,limiteCourbe.top,x,limiteCourbe.bottom)
       else segment(x,y,x,y+marge);
end;

Procedure graduationY(y : integer;quadrillage : boolean);
begin
   if quadrillage
       then segment(limiteCourbe.left,y,limiteCourbe.right,y)
       else segment(xAxeY,y,xAxeY+signeMargeX*marge,y);
end;

  procedure initAxeX;
  var x1,y1 : Integer;
  begin	with voie[voieT] do begin
       PointCourant := PointDebut;
       canvas.pen.style := psSolid;
       canvas.pen.width := 1;
       canvas.pen.color := CouleurAxe;
       WindowAxe(0,0,voieA,x1,y1);
            if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then
            with limiteCourbe do segment(x1,bottom,x1,top);
    xNombreMax := limiteFenetre.right-largCarac*NbreChiffres div 2;
    xNombreMin := limiteFenetre.left+largCarac*NbreChiffres div 2;
              TraceTitreAxe(voieT,false);
              with limiteFenetre do begin
               segment(left,yAxeX,right,yAxeX);
          { flche }
               segment(right-marge*3,yAxeX+marge,right,yAxeX);
               segment(right-marge*3,yAxeX-marge,right,yAxeX);
          end;
//	        SetTextAlign(TA_center+TA_top);
          Xcentre := true;
          SigneAligneY := +1;
  end end;{initAxeX}

  procedure traceAxeX;
  var xs,ys : Integer;
      NombreAff : shortstring;
      Xmax : double;
  begin with voie[voieT] do begin
       if Quadrillage then begin
          canvas.pen.style := psDot;
          canvas.pen.width := 1;
          canvas.pen.color := couleurAxe;
       end;
       Xmax := maxi;
       repeat
          windowAxe(PointCourant,voie[voieA].Mini,voieA,xs,ys);
          if XcorrectGrad(xs) then begin
               ys := yAxeX;
               if Quadrillage then if imprimanteEnCours
                      then begin
                         canvas.pen.style := psDot;
                         canvas.pen.width := 3;
                      end
                      else begin
                           canvas.pen.style := psSolid;
                           canvas.pen.width := 1;
                      end;
               graduationX(xs,ys,Quadrillage);
               if Quadrillage then begin
                     canvas.pen.style := psDot;
                     canvas.pen.width := 1;
               end;
               if XcorrectNombre(xs) then begin
              	 if abs(PointCourant)< (Maxi-Mini)/100 then pointCourant := 0;
                 NombreAff := formatMonde(pointCourant/exposant);
             	   OutText(xs,ys+marge,NombreAff);
      	       end;
          end;
      	  PointCourant := PointCourant+deltaAxe;
      until ( PointCourant>=Xmax );
      canvas.pen.width := 1;
 end end;{traceAxeX}

 procedure initAxeY(m : indiceVoieOsc);
 var x1,y1 : Integer;
 begin with voie[m] do begin
        TraceTitreAxe(m,false);
        PointCourant := PointDebut;
        canvas.pen.style := psSolid;
        canvas.pen.width := 1;
        canvas.pen.color := CouleurAxe;
           WindowAxe(0,0,m,x1,y1);
           if (y1>CourbeTop) and (y1<CourbeBottom)then
                 with limiteCourbe do begin
              	      segment(left,y1,right,y1);
                  { flche }
                      segment(right-marge*3,y1+marge,right,y1);
                      segment(right-marge*3,y1-marge,right,y1);
          	     end;
        segment(xAxeY,CourbeBottom,xAxeY,CourbeTop);
           segment(xAxeY-marge,courbeTop+3*marge,xAxeY,courbeTop);
           segment(xAxeY+marge,courbeTop+3*marge,xAxeY,courbeTop);
          canvas.font.color := couleurAxe;
        SigneAligneY := -1;
{
      	if (m=voieB)
	         then setTextAlign(TA_left+TA_bottom)
           else setTextAlign(TA_right+TA_bottom);
}           
        Xcentre := false;
 end end;{initAxeY}

 procedure traceAxeY(m : indiceVoieOsc);
 var xs,ys : Integer;
     nombreAff : shortstring;
     Ymax : double;
 begin with voie[m] do begin
      if Quadrillage then begin
          canvas.pen.style := psDot;
          canvas.pen.width := 1;
          canvas.pen.color := couleurAxe;
      end;
      Ymax := maxi;
      repeat
           windowAxe(voie[voieT].Mini,PointCourant,m,xs,ys);
	   {coordonne cran de marque}
	         if YcorrectGrad(ys,m) then begin
                 if Quadrillage then if imprimanteEnCours
                       then begin
                         canvas.pen.style := psDot;
                         canvas.pen.width := 3;
                       end
                       else begin
                          canvas.pen.style := psSolid;
                          canvas.pen.width := 1;
                    end;
         	       if YcorrectNombre(ys,m) then begin
	   	              if abs(pointCourant) < (Maxi-Mini)/1000 then pointCourant := 0;
                       NombreAff := formatMonde(pointCourant/exposant);
           	   	    OutText(xAxeY+signeMargeX*marge,ys+marge,NombreAff);
                 end;
                 graduationY(ys,quadrillage);
                 if Quadrillage then begin
                        canvas.pen.style := psDot;
                        canvas.pen.width := 1;
                 end;
	         end;
	         pointCourant := pointCourant+deltaAxe;
      until ( pointCourant>=Ymax );
      canvas.pen.width := 1;
end end;{traceAxeY}

  procedure zeroX;
  var x1,y1 : Integer;
  begin with voie[voieT] do begin
	  WindowAxe(0,0,voiea,x1,y1);
	  if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
          canvas.pen.style := psSolid;
          canvas.pen.width := 1;
          canvas.pen.color := CouleurAxe;
              with limiteCourbe do begin
      	           segment(x1,bottom,x1,top);
                        { flche }
                   segment(x1-marge,top+3*marge,x1,top);
                   segment(x1+marge,top+3*marge,x1,top);
              end;
	  end;
     end end;{zeroX}

 procedure zeroY(m : indiceVoieOsc);
 var x1,y1 : Integer;
 begin with voie[m] do begin
	windowAxe(0,0,m,x1,y1);
	if (y1>CourbeTop) and  (y1<CourbeBottom) then begin
          canvas.pen.style := psSolid;
          canvas.pen.width := 1;
          canvas.pen.color := CouleurAxe;
           with limiteCourbe do begin
    	         segment(left,y1,right,y1);
                     { flche }
               segment(right-marge*3,y1+marge,right,y1);
               segment(right-marge*3,y1-marge,right,y1);
           end;
	end
  end end;{zeroY}

begin // DrawAxis
     signeMargeX := -1;
     canvas.font.color := CouleurAxe;
     xAxeY := limiteCourbe.left;
     yAxeX := limiteCourbe.bottom;
     voie[voieT].xTitre := limiteFenetre.right-marge;
     voie[voieT].yTitre := yAxeX+2*hautCarac;
             with voie[voieA] do  begin
                xTitre := xAxeY-NbreChiffres*largCarac;
                yTitre := limiteFenetre.Top;
             end;
             with voie[voieB] do  begin
                xTitre := limiteFenetre.right-marge;
                yTitre := limiteFenetre.Top;
             end;
     initAxeX;
      traceAxeX;
          zeroX;
     if voie[voieA].active then begin
             initAxeY(voieB);
                   traceAxeY(voieA);
              zeroY(voieA);
     end;
     if voie[voieB].active then begin
              xAxeY := limiteCourbe.right;
              signeMargeX := +1;
           initAxeY(voieB);
                  traceAxeY(voieB);
               zeroY(voieB);
     end;
//     SetTextAlign(TA_left+TA_top);
end; // DrawAxis 


