unit Hm407com;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
     sysutils, StdCtrls, ExtCtrls, oomisc, jmmutil;

type
  TComCfgDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Comports: TRadioGroup;
    VitesseComRG: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    NumeroCom : array[0..MaxComHandles] of byte;
  public
    Numero : byte;
  end;

var
  ComCfgDlg: TComCfgDlg;

implementation

{$R *.DFM}

procedure TComCfgDlg.FormActivate(Sender: TObject);
var i : integer;
begin
    ComPorts.items.clear;
    for i := 1 to MaxComHandles do
        if IsPortAvailable(i) then begin
           ComPorts.Items.Add('COM'+IntToStr(i));
           NumeroCom[ComPorts.Items.count-1] := i;
           if i=Numero then ComPorts.itemIndex := ComPorts.Items.count-1;
        end;
    if ComPorts.itemIndex<0 then ComPorts.itemIndex := 0;
end;

procedure TComCfgDlg.OKBtnClick(Sender: TObject);
begin
    Numero := NumeroCom[ComPorts.itemIndex]
end;

end.
