unit Hmcom;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  sysutils, StdCtrls, ExtCtrls, oomisc, jmmutil;

type
  TComCfgDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Comports: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    NumeroCom : array[0..32] of byte;
  public
    Numero : byte;
  end;

var
  ComCfgDlg: TComCfgDlg;

implementation

{$R *.DFM}

procedure TComCfgDlg.FormActivate(Sender: TObject);
var i,indexCourant : integer;
begin
    ComPorts.items.clear;
    for i := 1 to MaxComHandles do
        if IsPortAvailable(i) then begin
           ComPorts.Items.Add('COM'+IntToStr(i));
           indexCourant := ComPorts.Items.count-1;
           NumeroCom[indexCourant] := i;
           if i=Numero then ComPorts.itemIndex := indexCourant;
    end;
    if ComPorts.itemIndex<0 then ComPorts.itemIndex := 0;
end;

procedure TComCfgDlg.OKBtnClick(Sender: TObject);
begin
    Numero := NumeroCom[ComPorts.itemIndex]
end;

end.
